-------------------------------------------------------------------------------
-- Title      : Testbench for design "compteur_modulo6"
-- Project    :
-------------------------------------------------------------------------------
-- File       : compteur_modulo6_tb.vhd
-- Author     : Matthieu Arzel  <marzel@marzel-XPS-13-9350>
-- Company    :
-- Created    : 2019-01-10
-- Last update: 2023-10-04
-- Platform   :
-- Standard   : VHDL'93/02
-------------------------------------------------------------------------------
-- Description:
-------------------------------------------------------------------------------
-- Copyright (c) 2019
-------------------------------------------------------------------------------
-- Revisions  :
-- Date        Version  Author  Description
-- 2019-01-10  1.0      marzel  Created
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

-------------------------------------------------------------------------------

entity compteur_modulo6_tb is
end entity compteur_modulo6_tb;

-------------------------------------------------------------------------------

architecture arch of compteur_modulo6_tb is

    -- component ports
    signal rst    : std_logic := '0';
    signal bloque : std_logic := '0';
    signal sortie : std_logic_vector(2 downto 0);

    -- clock
    signal Clk : std_logic := '1';

begin  -- architecture arch

    -- component instantiation
    DUT : entity work.compteur_modulo6
        port map (
            I_clk         => clk,
            I_rst         => rst,
            I_bloque      => bloque,
            O_counterMod6 => sortie);

    -- clock generation
    Clk <= not Clk after 10 ns;

    -- waveform generation
    rst    <= '0', '1' after 6 ns, '0' after 27 ns, '1' after 128 ns, '0' after 147 ns;
    bloque <= '0', '1' after 33 ns, '0' after 76 ns;



end architecture arch;

-------------------------------------------------------------------------------

configuration compteur_modulo6_tb_arch_cfg of compteur_modulo6_tb is
    for arch
    end for;
end compteur_modulo6_tb_arch_cfg;

-------------------------------------------------------------------------------
